#!/usr/local/bin/perl

print "Content-type: text/html", "\n\n";
print "<html><body>";

if($ENV{'REQUEST_METHOD'} eq "POST") {
  read(STDIN, $QueryString, $ENV{'CONTENT_LENGTH'});
} else {
  $QueryString = $ENV{QUERY_STRING};
}

@NameValuePairs = split (/&/, $QueryString);

foreach $NameValue (@NameValuePairs) {
  ($Name, $Value) = split (/=/, $NameValue);
  $Value =~ tr/+/ /;
  $Value =~ s/%([\dA-Fa-f][\dA-Fa-f])/ pack ("C",hex ($1))/eg;
  $Form{$Name} = $Value;
}

if ( $Form{"step"} eq "1" ) {

    print "<CENTER><H2>WebDrill</H2><BR><H3>New User Sign-up Form</H3><BR>Step 1 of 2</CENTER>";
    print "<FORM ACTION=\"signup.pl\" METHOD=\"POST\">";
    print "<INPUT TYPE=\"hidden\" NAME=\"step\" VALUE=\"2\">";
    print "<table border=\"0\">";
    print "<tr><td>User name :</td> <td><INPUT TYPE=\"text\" SIZE=\"20\" NAME=\"UNAME\"></td></tr>";
    print "<tr><td>Your name :</td> <td><INPUT TYPE=\"text\" SIZE=\"20\" NAME=\"NAME\"></td></tr>";
    print "<tr><td>Email address :</td> <td><INPUT TYPE=\"text\" SIZE=\"20\" NAME=\"MAIL\"></td></tr>";
    print "</table>";
    print "<BR><INPUT TYPE=\"submit\" NAME=\"Submit\">";
    print "</FORM>";

} elsif ( $Form{"step"} eq "2" ) {

    &get_user_names ("/home/motreja/.htpasswds/cgi-bin/webdrill/passwd", \@usernames);

    $user = $Form{"UNAME"};

    foreach $username (@usernames) {
        if ($user eq $username) {
            print "<CENTER><H2>WebDrill</H2><BR>That user name already exists.<BR>Please select another one.</CENTER>";
            exit(0);
        }
    }

    $CONF_CODE = int( rand(20000));

    open (USER_DATA, ">data/users/$user.dat");

    print USER_DATA "UNAME=$Form{\"UNAME\"}\n";
    print USER_DATA "NAME=$Form{\"NAME\"}\n";
    print USER_DATA "MAIL=$Form{\"MAIL\"}\n";
    print USER_DATA "CONF_CODE=$CONF_CODE\n";

    close (USER_DATA);

    open (CONF_CODE_MAIL, "| /usr/sbin/sendmail -t");

    print CONF_CODE_MAIL "To:$Form{\"MAIL\"}\n";
    print CONF_CODE_MAIL "From:webdrill\@motreja.com\n";
    print CONF_CODE_MAIL "Subject:WebDrill email address validation code\n";
    print CONF_CODE_MAIL "Hi $Form{\"NAME\"},\n\n";
    print CONF_CODE_MAIL "Your email address validation code is $CONF_CODE\n";
    print CONF_CODE_MAIL "Please reply to this mail if you have problems.\n\n";
    print CONF_CODE_MAIL "This mail is sent as you have tried to subscribe to WebDrill at http://motreja.com/ankur/webdrill\n";
    print CONF_CODE_MAIL "You need to enter the validation code given above before your account can be activated\n";
    print CONF_CODE_MAIL "\nRegards,\nWebDrill Webmaster";

    close(CONF_CODE_MAIL);

    print "<CENTER><H2>WebDrill</H2><BR><H3>New User Sign-up Form</H3><BR>Step 2 of 2</CENTER>";
    print "<FORM ACTION=\"signup.pl\" METHOD=\"POST\">";
    print "<INPUT TYPE=\"hidden\" NAME=\"step\" VALUE=\"3\">";
    print "<BR>A mail has been sent to $Form{\"MAIL\"}";
    print "<table border=\"0\">";
    $temp = $Form{"UNAME"};
    print "<tr><td>User Name :</td> <td><INPUT TYPE=\"hidden\" NAME=\"UNAME\" VALUE=\"$temp\">$temp</td></tr>";
    $temp = $Form{"NAME"};
    print "<tr><td>Your name :</td> <td><INPUT TYPE=\"hidden\" NAME=\"NAME\" VALUE=\"$temp\">$temp</td></tr>";
    $temp = $Form{"MAIL"};
    print "<tr><td>Email address :</td> <td><INPUT TYPE=\"hidden\" NAME=\"MAIL\" VALUE=\"$temp\">$temp</td></tr>";
    print "<tr><td>Email address validation code :</td> <td><INPUT TYPE=\"text\" SIZE=\"20\" NAME=\"CONF_CODE\"></td></tr>";
    print "<tr><td>Password :</td> <td><INPUT TYPE=\"password\" SIZE=\"20\" NAME=\"PASS1\"></td></tr>";
    print "<tr><td>Confirm password :</td> <td><INPUT TYPE=\"password\" SIZE=\"20\" NAME=\"PASS2\"></td></tr>";
    print "</table>";
    print "<BR><INPUT TYPE=\"submit\" NAME=\"Submit\">";
    print "</FORM>";

} elsif ( $Form{"step"} eq "3" ) {

    $user = $Form{"UNAME"};
    &parse_file ("/home/motreja/www/cgi-bin/webdrill/data/users/$user.dat", \%User_data);

    if ($Form{"CONF_CODE"} ne $User_data{"CONF_CODE"}) {
        print "<CENTER><H2>WebDrill</H2><BR>The email address validation code is incorrect.</CENTER>";
        exit(0);
    }

    if ($Form{"PASS1"} ne $Form{PASS2}) {
        print "<CENTER><H2>WebDrill</H2><BR>The passwords you have entered don\'t match.</CENTER>";
        exit(0);
    }

    $pass = $Form{"PASS1"};

    `htpasswd -b /home/motreja/.htpasswds/cgi-bin/webdrill/passwd \"$user\" \"$pass\"`;
    `mkdir \"/home/motreja/www/cgi-bin/webdrill/users/$user\"`;
    `mkdir \"/home/motreja/www/cgi-bin/webdrill/users/$user/db\"`;
    `cp \"/home/motreja/www/cgi-bin/webdrill/users/db.config\" \"/home/motreja/www/cgi-bin/webdrill/users/$user/\"`;
    `cp \"/home/motreja/www/cgi-bin/webdrill/users/config\" \"/home/motreja/www/cgi-bin/webdrill/users/$user/db/\"`;
    `mkdir \"/home/motreja/www/ankur/webdrill/cache/$user\"`;
    `mkdir \"/home/motreja/www/ankur/webdrill/saved/$user\"`;

    print "Your account has been created. Click <a href=\"http://www.motreja.com/cgi-bin/webdrill/display.pl?path=db\">here</a> to access it";

} else {

print "unknown step";

}






# Procs start here
# ================






sub get_user_names {

    local ($i, $uname, $line, $users);

    $users = $_[1];

    if (!open (USER_FILE, "$_[0]")) {
      print "ERROR: www_lookup: get_user_names: Unable to find $_[0]\n";
      return 0;
    }

    $i = 0;

    while (<USER_FILE>) {
        $line=$_;
        chop ($line);

        if ( ($line !~ /^#/) && ($line ne "") ) {
            ($uname) = split (/:/, $line);
            $$users[$i] = $uname;
            $i++;
        }
    }

    close(USER_FILE);
    return 1;

}


sub parse_file {

    local ($config_line, $Name, $Value, $Config, $date);

    $Config = $_[1];

    if (!open (CONFIG, "$_[0]")) {
      print "ERROR: www_lookup: parse_file: User info file $_[0] not found\n";
    }

    while (<CONFIG>) {
        $config_line=$_;
        chop ($config_line);
        $config_line =~ s/^\s*//;
        $config_line =~ s/\s*$//;
        if ( ($config_line !~ /^#/) && ($config_line ne "") ){
            ($Name, $Value) = split (/=/, $config_line);
            $$Config{$Name} = $Value;
        }
    }

    close(CONFIG);

}

